#include	<stdio.h>
#include	<string.h>
#include	<stdlib.h> //elks doesn't have this library? but crt0.S have "_exit"

#include 	<i86.h>
//#include 	<conio.h> elks doesn't have this library
#include	<malloc.h>

//#include "arch/io.h"		//gcc-ia16用?
#include "arch/ports.h"

#define	COUNTAT	1193180L	/* PC/XT 8253 clock */
#define	COUNT5		2457600L	/* timer clock freq.[Hz] at 5/10/20MHz */
#define	COUNT8		1996800L	/* timer clock freq.[Hz] at 8/16MHz */

unsigned char far	*BeepBuf;		/* data buffer pointer */
static int			playflag;
static long			playcount;
static long			playsize;
static unsigned int	count;
static unsigned int	count0;
static unsigned int	divcount;

//#define outportb	outb
//#define inportb	inb
//#define disable	_disable
//#define enable	_enable

unsigned int OrgTimerVectSEG;
unsigned int OrgTimerVectOFF;
unsigned int lowmode = 0;
long OrgTimerVect;
unsigned int playcount2 = 0;

static void disable(){
	_asm {
	cli
	}
}

static void enable(){
	_asm{
	sti
	}
}

void outportb(unsigned int ioport, unsigned char value){
	_asm{
	mov	dx,ioport
	mov	al,value
	out	dx,al
	}
}

unsigned char inportb(unsigned int ioport){
	unsigned char ret1;
	ret1= 0;//コンパイラがうるさい
	_asm{
	mov	dx,ioport
	in	al,dx
	mov	ret1,al
	}
	return ret1;
}

static long getvect(unsigned int intnumber){
	intnumber *= 4;
	unsigned int ret0,ret1;
	long ret;
	ret0 = ret1 = 0;//コンパイラがうるさい
	_asm{
	push	es
	mov	ax,0
	mov	es,ax
	mov	bx,intnumber
	mov	ax,[es:bx]
	add	bx,2
	mov	dx,[es:bx]
	pop	es
	mov	ret0,dx
	mov	ret1,ax
	}
	ret = ret0;
	ret = ret << 16;
	ret |= ret1;
	return ret;
}

static void setvect(unsigned int intnumber, long isr){
	intnumber *= 4;
	int isroff,isrseg;
	isroff = isr &0xffff;
	isrseg = isr >> 16;
	_asm{
	cli
	push	es
	mov	ax,0
	mov	es,ax
	mov	ax,isroff
	mov	bx,intnumber
	mov	es:[bx],ax
	mov	ax,isrseg
	add	bx,2
	mov	es:[bx],ax
	pop	es
	sti
	}
}


static void interrupt NewTimerVectBeep(void)
{
	static unsigned int	d;

//	printf("isr8 called count %x size %x flag %x\n",playcount,playsize,playflag);

	if(playcount < playsize){
		d=(unsigned int)(((unsigned int)BeepBuf[playcount++]*count)>>8)+1; //8bitPCM unsigned
/*
		d=BeepBuf[playcount++]; //8bitPCM unsigned
		d <<=8;//16bit化
		d &= 0xff00;
		d /= (0x10000/count);//正規化
*/
		outportb(0x3fdb, (d&0xff));//LSB	/* counter start */
		outportb(0x3fdb, (d>>8));//MSB	/* counter start */
		playcount += lowmode;
	}
	else
		playflag = 0;

 if(1){
	playcount2++;
	if(playcount2 == count0){//10ms 100Hz
		playcount2 = 0;
		_asm{
			push	bp
			mov	ax,OrgTimerVectSEG
			push	ax
			mov	ax,OrgTimerVectOFF
			push	ax
			mov	bp,sp
			pushf
			call	dword ptr [bp]
			add	sp,4		;;レジスタだけ触った方がよいかも
//			pop	ax		;;memory access 遅い
//			pop	ax
			pop	bp
		}
	}
 }
	outportb(0x00,0x20);//本物がやる場合に先取りするとダメ
	if(playflag == 0){//途中でCTRL-C押してしまった場合にはタイマー割り込み処理が続けられる その終端処理
		setvect(0x08,OrgTimerVect);

		/*ｶｳﾝﾀ1(ﾋﾞｰﾌﾟ)の設定*/
		outportb(0x35,(inportb(0x35)|0x08));	/* beep off */
		outportb(0x77,0x76);					/* set timer #1 to mode 3 */
		d = (inportb (0x42) & 0x20)?0x80:0;
		d = (inportb (0x42) == 0xff)?0:d;
		if(d & 0x80){
			count=(unsigned int)((long)COUNT8/2000);
		}
		else{
			count=(unsigned int)((long)COUNT5/2000);
		}
		/*ｶｳﾝﾀ1(ﾋﾞｰﾌﾟ)のｶｳﾝﾄ値*/
		outportb(0x3fdb,(unsigned char)(count&0x00ff));
		outportb(0x3fdb,(unsigned char)(count>>8));		/* set freq 2,000Hz */
	}

}


static void interrupt NewTimerVectBeep16(void)
{
	static unsigned int d;
	if(playcount < playsize){
		d = BeepBuf[playcount+1];	//16bit signed PCM Little endian upper
		d <<= 8;
		d |= BeepBuf[playcount];	//16bit signed PCM lower
		d ^= 0x8000;//Unsigned化
		d /= divcount;//先に計算しておいた数値でやる(0x10000/count);//正規化
		outportb(0x3fdb, (d & 0xff));	//LSB
		outportb(0x3fdb, (d>>8));		//MSB
	}
	else
		playflag = 0;
	playcount +=2;
	playcount += lowmode;
 if(1){
	playcount2++;
	if(playcount2 == count0){
		playcount2 = 0;
		_asm{
			push	bp
			mov	ax,OrgTimerVectSEG
			push	ax
			mov	ax,OrgTimerVectOFF
			push	ax
			mov	bp,sp
			pushf
			call	dword ptr [bp]
			add	sp,4
			pop	bp
		}
	}
 }
	outportb(0x00,0x20);

	if(playflag == 0){//途中でCTRL-C押してしまった場合に
		setvect(0x08,OrgTimerVect);

		/*ｶｳﾝﾀ1(ﾋﾞｰﾌﾟ)の設定*/
		outportb(0x35,(inportb(0x35)|0x08));	/* beep off */
		outportb(0x77,0x76);					/* set timer #1 to mode 3 */
		d = (inportb (0x42) & 0x20)?0x80:0;
		d = (inportb (0x42) == 0xff)?0:d;
		if(d & 0x80){
			count=(unsigned int)((long)COUNT8/2000);
		}
		else{
			count=(unsigned int)((long)COUNT5/2000);
		}
		/*ｶｳﾝﾀ1(ﾋﾞｰﾌﾟ)のｶｳﾝﾄ値*/
		outportb(0x3fdb,(unsigned char)(count&0x00ff));
		outportb(0x3fdb,(unsigned char)(count>>8));		/* set freq 2,000Hz */
	}
}


long LoadBF(char *wavename)
{
	FILE *fp;
	long fsize=0;
	int read;

	if((fp = fopen(wavename, "rb")) == NULL) {
		fprintf(stderr, "Error! file open failed.\n");
		return -1L;
	}

	while((read=fgetc(fp))!=EOF){
		BeepBuf[fsize]=(char)read;
		fsize++;
		if(fsize == 65535)goto loadend;
	}
loadend:
	fclose(fp);
	return(fsize);
}

void PlayWaveXT(long Fsize,long khz)
{

}

void PlayWave(long Fsize,long khz)
{
//	long OrgTimerVect,isr;
	long isr;
	unsigned char imr_m, imr_s;
	char	BIOS_FLAG;
	unsigned int	count_o;


//	disable();								/* cli */
//	outportb(0x02,inportb(0x02)|0x01);		/* set timer mask bit */
//	enable();								/* sti */

	BIOS_FLAG = (inportb (0x42) & 0x20)?0x80:0;
	BIOS_FLAG = (inportb (0x42) == 0xff)?0:BIOS_FLAG;

	if(BIOS_FLAG & 0x80){				/* 8MHz/16MHz... */
		count=(unsigned int)((long)COUNT8/khz);
		count_o = (unsigned int)((long)COUNT8/100);
	}
	else{									/* 5MHz/10MHz... */
		count=(unsigned int)((long)COUNT5/khz);
		count_o = (unsigned int)((long)COUNT5/100);
}
	count0 = khz / 100;
	/*ｶｳﾝﾀ0(ｲﾝﾀｰﾊﾞﾙﾀｲﾏ)の設定*/
//	outportb(0x77,0x36);				/* counter mode 3 */
//	outportb(0x71,(unsigned char)(count&0x00ff));		/* rate LSB */
//	outportb(0x71,(unsigned char)(count>>8));			/* rate MSB */
//ぎりぎりまでタイマー側のIOは触らない

	playflag = 1;
	playsize = Fsize;

	OrgTimerVect = getvect(0x08);
	OrgTimerVectSEG = FP_SEG(OrgTimerVect);
	OrgTimerVectOFF = FP_OFF(OrgTimerVect);

	printf("Orginal vector8 %04x:%04x\n",FP_SEG(OrgTimerVect),FP_OFF(OrgTimerVect));


	if(BeepBuf[34] == 8){//unsigned 8bit PCM
	isr = 	FP_SEG(NewTimerVectBeep);
	isr = isr << 16;
	isr |= FP_OFF(NewTimerVectBeep);
	printf("new vector8 %04x:%04x\n",FP_SEG(NewTimerVectBeep),FP_OFF(NewTimerVectBeep));
	}else if(BeepBuf[34] == 16){//signed 16bit Little-Endian PCM
	lowmode <<= 1;
	divcount = 0x10000/count;
	isr = 	FP_SEG(NewTimerVectBeep16);
	isr = isr << 16;
	isr |= FP_OFF(NewTimerVectBeep16);
	printf("new vector8 %04x:%04x\n",FP_SEG(NewTimerVectBeep),FP_OFF(NewTimerVectBeep));
	}
	/*ｶｳﾝﾀ0(ｲﾝﾀｰﾊﾞﾙﾀｲﾏ)の設定*/
	outportb(0x77,0x36);						/* counter mode 3 */
	outportb(0x71,(unsigned char)(count&0x00ff));		/* rate LSB */
	outportb(0x71,(unsigned char)(count>>8));		/* rate MSB */

	setvect(0x08,isr);

	/*ｶｳﾝﾀ1(ｽﾋﾟｰｶｰ)の設定*/
	outportb(0x77,0x70);		/* set timer #1 to mode 0 */
	outportb(0x35,(inportb(0x35)&(0xff-0x08)));	/* beep on */
	disable();								/* cli */
//	outportb(0x02,inportb(0x02)&(~0x01));	/* clear timer mask bit */
	outportb(0x02,(imr_m=(unsigned char)inportb(0x02))|(0x00));
	outportb(0x0a,(imr_s=(unsigned char)inportb(0x0a))|(0x20));//IR13禁止 不要?
	enable();								/* sti */

	while(playflag){};

	/*ｶｳﾝﾀ0(ｲﾝﾀｰﾊﾞﾙﾀｲﾏ)の設定戻す*/
	outportb(0x77,0x36);						/* counter mode 3 */
	outportb(0x71,(unsigned char)(count_o&0x00ff));		/* rate LSB */
	outportb(0x71,(unsigned char)(count_o>>8));		/* rate MSB */


	disable();								/* cli */
	outportb(0x02,imr_m);
	outportb(0x0a,imr_s);
//	outportb(0x02,inportb(0x02)|0x01);		/* set timer mask bit */
	enable();								/* sti */

	setvect(0x08,OrgTimerVect);

	/*ｶｳﾝﾀ1(ﾋﾞｰﾌﾟ)の設定*/
	outportb(0x35,(inportb(0x35)|0x08));	/* beep off */
	outportb(0x77,0x76);					/* set timer #1 to mode 3 */
	if(BIOS_FLAG & 0x80){
		count=(unsigned int)((long)COUNT8/2000);
	}
	else{
		count=(unsigned int)((long)COUNT5/2000);
	}
	/*ｶｳﾝﾀ1(ﾋﾞｰﾌﾟ)のｶｳﾝﾄ値*/
	outportb(0x3fdb,(unsigned char)(count&0x00ff));
	outportb(0x3fdb,(unsigned char)(count>>8));		/* set freq 2,000Hz */

//	disable();								/* cli */
//	outportb(0x02,inportb(0x02)&(~0x01));	/* clear timer mask bit */
//	outportb(0x02,inportb(0x02)|(01));	/* re-set timer mask bit */
//	enable();								/* sti */
}


/*
 *	main function
 *****************************************************************************/
void main(int argc, char *argv[])
{
	char wavename[80];
	long fsize,freq;
	char isPC98;

	BeepBuf=(unsigned char far *)fmemalloc(65536);
	if(BeepBuf == NULL) exit(1);
	printf("malloc at %04x:%04x\n",FP_SEG(BeepBuf),FP_OFF(BeepBuf));
/*
	strcpy(wavename,"uname -a > /tmp/uname");
	system(command, wavename);
	strcpy(wavename,"/tmp/uname");
	fsize = LoadBF(wavename);
	strcpy(wavename,"rm /tmp/uname");
	system(command, wavename);

	if(BeepBuf[fsize-6] == '8'){
		printf("machine is PC98\n");
		isPC98 = 1;
	}else isPC98 = 0;
*/
	isPC98 = 1;

	if(argc>1){
		strcpy(wavename,argv[1]);
		if ((wavename[0] == '-')&&(wavename[1] == 'l')){
			lowmode = 2;strcpy(wavename,argv[argc-1]);
		}
	}else{
	 strcpy(wavename,"weskar.spk");
	 freq = 22050;
	}

	printf("Loading wave ... ");
	if((fsize=LoadBF(wavename)) < 0L) {
		printf("wavename %c\n",wavename);
		exit(1);
	}
	if((BeepBuf[0] != 'R')||(BeepBuf[1] !='I')||(BeepBuf[2] != 'F')||(BeepBuf[3] != 'F'))
		exit(1);
	if(BeepBuf[20] != 1)		//PCM
		exit(1);

	freq = BeepBuf[25];
	freq = freq << 8;
	freq |= BeepBuf[24];
	printf("WAV sample %uHz ",freq);
	if (freq < 13000)lowmode = 0;
	if(lowmode){
		for(lowmode = 1;freq > 13000;lowmode<<=1){
			freq >>= 1;//周波数を半減していく
		}
	printf("play with %uHz ",freq);
	}
	if(BeepBuf[34] == 8){//unsigned 8bit PCM
		printf("Unsigned 8bit ");
	}else if(BeepBuf[34] == 16){
		printf("Signed 16bit(LE) ");
	}
	if(BeepBuf[22]==2){//モノラルかステレオかしか判別不可 マルチチャンネルPCMとか無視
		printf("stereo\n");
		if(lowmode == 0)lowmode = 1;
		lowmode <<= 1;//stereoの場合は飛ばすサイズは倍 左だけ鳴らす 混ぜない
	}else printf("mono\n");
	playcount = 12;
datachk:
	if(playcount > 500)exit(1);
	if((BeepBuf[playcount] != 'd')||(BeepBuf[playcount+1] !='a')||(BeepBuf[playcount+2] != 't')||(BeepBuf[playcount+3] != 'a')){
		playcount += BeepBuf[playcount+4]+8;
		goto datachk;
	}
	playcount += 8;
	printf("OK(%ldbytes).\n",fsize);
	printf("Playing wave ... ");
	if(lowmode){
		lowmode--;
		printf("lowmode %d\n",lowmode);
	}
	if(isPC98)
	PlayWave(fsize,freq);
	else
	PlayWaveXT(fsize,freq);

	printf("END.\n");
	free(BeepBuf);
}
